## mingw-w64-skia-130.r73211.b988efa0-4.src.tar.zst

=== infra/docker/Makefile ===

publish_debian9:
	docker build -t debian9 ./debian9/
	docker tag debian9 gcr.io/skia-public/debian9
	docker push gcr.io/skia-public/debian9

=== infra/gcc/Makefile ===
publish_Debian11:
	docker build -t gcc-debian11 ./Debian11/
	docker tag gcc-debian11 gcr.io/skia-public/gcc-debian11
	docker push gcr.io/skia-public/gcc-debian11

publish_Debian11-x86:
	docker build -t gcc-debian11-x86 ./Debian11-x86/
	docker tag gcc-debian11-x86 gcr.io/skia-public/gcc-debian11-x86
	docker push gcr.io/skia-public/gcc-debian11-x86

=== infra/skottie/Makefile ===
BAZEL?=bazelisk

.PHONY: build
build:
	$(BAZEL) run //infra/skottie:skottie_container \
	--config=skottie_container

# Review section in README.md before running this target
.PHONY: push_skottie_I_am_really_sure
push_skottie_I_am_really_sure:
	$(BAZEL) run //infra/skottie:push_skottie_container \
	--config=skottie_container

=== modules/canvaskit/Makefile ===
clean:
	- rm -rf ../../out/canvaskit_wasm
	- rm -rf ./npm_build/bin
	- rm -rf ./build/
	$(MAKE) release

release:
	# Does an incremental build where possible.
	./compile.sh
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

release_cpu:
	# Does an incremental build where possible.
	./compile.sh cpu_only
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

release_webgpu:
	# Does an incremental build where possible.
	./compile.sh use_webgpu
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

release_viewer:
	# Does an incremental build where possible.
	./compile.sh viewer
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

debug:
	# Does an incremental build where possible.
	./compile.sh debug_build
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

debug_cpu:
	# Does an incremental build where possible.
	./compile.sh debug_build cpu_only
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

debug_webgpu:
	# Does an incremental build where possible.
	./compile.sh debug_build use_webgpu
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

debug_viewer:
	# Does an incremental build where possible.
	./compile.sh debug_build viewer
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

profile:
	./compile.sh profiling
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_profile/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_profile/canvaskit.wasm ./build/

npm:
	rm -rf ./npm_build/bin
	mkdir -p ./npm_build/bin
	cp ./CHANGELOG.md ./npm_build/

	mkdir -p ./npm_build/bin/full
	./compile.sh release
	cp ../../out/canvaskit_wasm/canvaskit.js       ./npm_build/bin/full
	cp ../../out/canvaskit_wasm/canvaskit.wasm     ./npm_build/bin/full

	# These features are turned off to keep code size smaller for the
	# general use case.
	./compile.sh release no_skottie no_sksl_trace no_alias_font \
		no_effects_deserialization no_encode_jpeg no_encode_webp legacy_draw_vertices \
		no_embedded_font
	cp ../../out/canvaskit_wasm/canvaskit.js       ./npm_build/bin
	cp ../../out/canvaskit_wasm/canvaskit.wasm     ./npm_build/bin

	mkdir -p ./npm_build/bin/profiling
	./compile.sh profiling
	cp ../../out/canvaskit_wasm_profile/canvaskit.js       ./npm_build/bin/profiling
	cp ../../out/canvaskit_wasm_profile/canvaskit.wasm     ./npm_build/bin/profiling

gm_tests_debug:
	./compile_gm.sh debug
	- rm -rf build/
	mkdir build
	cp ../../out/wasm_gm_tests_debug/wasm_gm_tests.js       ./build
	cp ../../out/wasm_gm_tests_debug/wasm_gm_tests.wasm     ./build

gm_tests:
	./compile_gm.sh
	- rm -rf build/
	mkdir build
	cp ../../out/wasm_gm_tests/wasm_gm_tests.js       ./build
	cp ../../out/wasm_gm_tests/wasm_gm_tests.wasm     ./build

single-gm:
	echo "Go check out http://localhost:8000/wasm_tools/gms.html"
	python3 ../../tools/serve_wasm.py

local-example:
	echo "Go check out http://localhost:8000/npm_build/example.html"
	python3 ../../tools/serve_wasm.py

test-continuous:
	echo "Assuming npm ci has been run by user"
	echo "Also assuming make debug or release has also been run by a user (if needed)"
	npx karma start ./karma.conf.js --no-single-run --watch-poll

test-continuous-headless:
	npx karma start ./karma.conf.js --no-single-run --watch-poll --headless

node-example:
	node ./npm_build/node.example.js --expose-wasm

docker-compile:
	mkdir -p ${SKIA_ROOT}/out/canvaskit_wasm_docker
	docker run --rm --volume ${SKIA_ROOT}:/SRC \
               --volume ${SKIA_ROOT}/out/canvaskit_wasm_docker:/OUT \
               gcr.io/skia-public/canvaskit-emsdk:2.0.0_v1 \
               /SRC/infra/canvaskit/build_canvaskit.sh

typecheck:
	echo "Make sure you've run cd npm_build && npm ci recently"
	cd npm_build && npm run dtslint

bazel_canvaskit_debug:
	bazelisk build :canvaskit --config=ck_full_webgl2_debug
	- rm -rf build/
	mkdir build
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.js build/canvaskit.js
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.wasm build/canvaskit.wasm

bazel_canvaskit_release:
	bazelisk build :canvaskit --config=ck_full_webgl2_release
	- rm -rf build/
	mkdir build
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.js build/canvaskit.js
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.wasm build/canvaskit.wasm
	ls -l build

bazel_test_canvaskit:
	bazelisk test :canvaskit_js_tests --config=ck_full_webgl2_release_chrome --test_output=streamed
	echo "test output in //bazel-testlogs/modules/canvaskit/canvaskit_js_tests/test.outputs/"
	cd ../../bazel-testlogs/modules/canvaskit/canvaskit_js_tests/test.outputs/ && unzip -qo outputs.zip && ls

with_debugger:
	# Does an incremental build where possible.
	./compile.sh debug_build enable_debugger
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/
	- mkdir ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.js         ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.wasm       ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./npm_build/types/index.d.ts ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/canvaskit.d.ts

with_debugger_release:
	./compile.sh enable_debugger
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/
	- mkdir ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.js         ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.wasm       ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./npm_build/types/index.d.ts ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/canvaskit.d.ts

for_shaders:
	./compile.sh
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/
	- mkdir ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/
	cp ./build/canvaskit.js         ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/
	cp ./build/canvaskit.wasm       ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/
	cp ./npm_build/types/index.d.ts ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/canvaskit.d.ts

=== infra/bots/analysis/Makefile ===
missing_perf_jobs:
	./missing.sh '$$Type == "Perf"'

missing_test_jobs:
	./missing.sh '$$Type == "Test"'

missing_vulkan_jobs:
	./missing.sh '$$vulkan == "true"'

=== PKGBUILD ===
# Maintainer: Naveen M K <naveen521kk at gmail.com>
# Contributor: Raed Rizqie <raed.rizqie@gmail.com>

_realname=skia
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=130.r73211.b988efa0
pkgrel=4
pkgdesc="Skia is a complete 2D graphic library for drawing Text, Geometries, and Images (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://skia.org"
msys2_repository_url="https://skia.googlesource.com/skia"
msys2_documentation_url="https://skia.org/docs"
license=("spdx:BSD-3-Clause")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-harfbuzz"
         "${MINGW_PACKAGE_PREFIX}-icu"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-gn"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-python"
             "git")
_commit="b988efa06f8aa3bfeaa18c5b8c716ff244ab43cf"
source=("${_realname}.tar.gz::https://github.com/google/skia/archive/${_commit}.tar.gz"
        "bare-clones/zlib::git+https://chromium.googlesource.com/chromium/src/third_party/zlib.git#commit=646b7f569718921d7d4b5b8e22572ff6c76f2596"
        "0001-add-pkgconfig-support.patch"
        "0002-add-mingw-toolchain-skia.patch"
        "0003-fix-dwrite-function-mingw.patch"
        "0004-misc-mingw-fixes.patch"
        "0005-external-packages-update.patch"
        "0006-integrates-svg-into-skia-lib.patch"
        "skia.pc")
sha256sums=('6ae175029bcf3e7e7368aa9dc0f744b59f4c0e0e096dc204a65c5560761f6f6e'
            '967acb8025f9af3f1a5d4d4e9ab671a65fd9b1a52e93081683f84167077c979b'
            '7440572487b8bc33ac7a8445de0cc4148e0d47b538ba46f4952ba8cc97e0fa52'
            '252f49523d53a2b74d0efb60678de1ca491df28c71ee4d1504684a1414ec3503'
            '107526f649a31ff87033608cb1f55c0922d6bd40fa3c8c769ed0320b9230cde6'
            '5d934a3a9deeea37b4f67daa83f9c4716e6b90b7f8829ca6588d0a0829561b0c'
            '9ad4b876437bc83df8baf72051c9e919529a754b681c434316f119e8440d8996'
            '1ead6b6e2e706b20f070ea3f86ca05648fedcc6afa70d415c5e39bd3712a1e7e'
            'f0b20d04cee41207a6f974d468e05be63dc3f7ed02992e118660b5bf279e757b')

apply_patch_with_msg() {
  for _patch in "$@"; do
      msg2 "Applying $_patch"
      patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

pkgver() {
  git clone --filter=blob:none --revision "${_commit}" https://skia.googlesource.com/skia.git skia_temp
  cd skia_temp
  local _milestone=$(grep -Eo "Milestone ([0-9]+)" RELEASE_NOTES.md | head -1 | cut -f 2 -d ' ')
  printf "%s.r%s.%s" "${_milestone}" "$(git rev-list --count HEAD)" "$(git rev-parse --short=8 "${_commit}")"
  cd ..
  rm -Rf skia_temp
}

prepare() {
  mv "${_realname}-${_commit}" "${_realname}"
  cd ${_realname}
  apply_patch_with_msg \
    0001-add-pkgconfig-support.patch \
    0002-add-mingw-toolchain-skia.patch \
    0003-fix-dwrite-function-mingw.patch \
    0004-misc-mingw-fixes.patch \
    0005-external-packages-update.patch \
    0006-integrates-svg-into-skia-lib.patch

  mkdir -p third_party/externals/zlib
  cp -r "${srcdir}"/zlib/google third_party/externals/zlib

  # gn is expected to be in skia/bin
  cp ${MINGW_PREFIX}/bin/gn.exe bin/gn.exe

  sed -e "s|@PREFIX@|${MINGW_PREFIX}|g" \
      -e "s|@VERSION@|${pkgver}|g" -i "${srcdir}"/skia.pc
}

build() {
  local _buildtype=Release
  local _debug=false
  local _official=true
  if check_option "debug" "y"; then
      _buildtype=Debug
      _debug=true
      _official=false
  fi

  local _arch=x64
  if [[ ${CARCH} == aarch64 ]]; then
      _arch=arm64
  fi

  cd ${_realname}
  gn gen out/${_buildtype}-${MSYSTEM} --args="
    target_cpu=\"${_arch}\"
    cc=\"${CC}\"
    cxx=\"${CXX}\"
    is_debug=${_debug}
    is_official_build=${_official}
    is_component_build=true
    skia_use_dng_sdk=false
    skia_use_wuffs=false
    skia_use_xps=false"

  ninja -C out/${_buildtype}-${MSYSTEM}
}

package() {
  cd ${_realname}

  local _buildtype=Release
  if check_option "debug" "y"; then
    _buildtype=Debug
  fi

  install -d "${pkgdir}"/${MINGW_PREFIX}/bin
  install -Dm755 out/${_buildtype}-${MSYSTEM}/*.dll "${pkgdir}"/${MINGW_PREFIX}/bin/

  install -d "${pkgdir}"/${MINGW_PREFIX}/lib
  install -Dm755 out/${_buildtype}-${MSYSTEM}/*.dll.a "${pkgdir}"/${MINGW_PREFIX}/lib/

  install -d "${pkgdir}"/${MINGW_PREFIX}/include/skia
  cp --parents `find ./include -name \*.h` "$pkgdir"/${MINGW_PREFIX}/include/skia
  cp --parents `find ./modules -name \*.h` "$pkgdir"/${MINGW_PREFIX}/include/skia

  install -d "${pkgdir}"/${MINGW_PREFIX}/lib/pkgconfig
  install -Dm644 "${srcdir}/skia.pc" "${pkgdir}"/${MINGW_PREFIX}/lib/pkgconfig/

  install -d "${pkgdir}"/${MINGW_PREFIX}/share/licenses/skia
  install -Dm644 LICENSE* "${pkgdir}"/${MINGW_PREFIX}/share/licenses/${_realname}/
}
